#ifndef HelixPso_H
#define HelixPso_H 1

#include <vector>
#include <string>
//#include <iterator>
#include <algorithm>
#include "RNAParameters.h"
#include "options.h"
#include "Swarm.h"
extern "C" {
#include  "fold.h"
#include "fold_vars.h"
#include "utils.h"
#include "pair_mat.h"
#include "part_func.h"
}
//#include "RNAPredict.h"
//#include "mpicxx.h" 
//#include "mpi.h" 

 typedef struct
  {
    double value;
    int rank;
 }locstruct;  

class HelixPso{
 public:

  static double alpha;

  static int Distance(std::string str1,std::string str2);
  int StructureHasFrequency(std::string structure);
  std::string SelectLowestDistanceStructure();
  std::vector<std::string> ReturnMostFrequentStructures();
  std::vector<std::string> GetStructures();


  bool AcceptTransition(std::string str_new,std::string str_old);

static std::vector<std::pair<int,int> >  bp_native;
static std::vector<std::pair<int,int> >  bp_centroid;
static std::pair<int,int> best_pred_in_all_runs;
 static std::pair<int,int> best_lastgen;

 static double centroid_weight;
 //void GetBestOfGeneration();

static int rule;
  //  double time_waited;
  //double time_waited_after_compute;
  //double time_waited_after_gbest;
  //double time_waited_after_elitism;

  double t1;
  //  std::vector<std::vector<int> > genepool;
  //const static int min_genepool_size=10000;
  //static int genepool_size;
  bool gbest_changed;
 const static int debug=true;
 static std::vector<std::vector<int> > transposition1st_counter;
 static std::vector<std::vector<int> > transposition2nd_counter;
 static int transposition_count_sections; 
 int transposition_count_section;

 static std::vector<int> accepted_solution_counter;
 static int accepted_solution_count_sections; 
 int accepted_solution_count_section;
 
 int last_stat_update;
 static int sv_stat_sections;
 int sv_stat_section;
 static std::vector<int> sv_length_counter;
 static std::vector<double> sv_mass_counter;
 static std::vector<std::vector<double> > sv_distribution_counter;
 static std::vector<double> sv_mass_fractions;
 int sv_length;
 double sv_mass;
 int rank;
 int nprocs;
 int start_idx;
 int stop_idx;

 static double swap_select;
 static double evaporation_threshold;
 //  const static int debug=false;
  //sequence p->RNA
  int solutions_report_interval;
  std::vector<double> solutions_report;
  //the best solution in the previous round that will be carried over through elitism
  std::pair<double,std::vector<int> > elite_solution;
  static double sim_anneal_start;
  static double sim_anneal_end;
  double sim_anneal;
  int accepted_solution_count;
  int solution_count;
  int total_solutions;

  RNAParameters* p;
  std::string sequence;
  int clusters;
  int population;
  int iterations;
  static int iterations_done;
  //ants,iterations,evaporate,steps_per_turn,p_bonus_pbest,p_bonus_gbest
  SearchParameters* s;
  
  std::pair<double,std::vector<int> > best_solution;// std::string best_solution;
  static std::vector<std::vector<std::pair<int,int> > > stemlist;
  std::vector<std::pair<double,std::vector<int> > > chromosomes;
   std::vector<std::vector<std::pair<int,int> > > nodes;

  //chromosomes= std::vector<std::vector<int> >() ;
  std::vector<std::vector<bool> > changed;

  //  std::vector<std::vector<int> > pbest;
  std::vector<std::pair<double,std::vector<int> > > pbest;
  //  std::vector<std::vector<int> > gbest;
  std::vector<std::pair<double,std::vector<int> > > gbest;
  //  std::vector<std::vector<std::vector<int> > >clbest;
  std::vector<std::vector<std::pair<double,std::vector<int> > > >clbest;

  //  std::vector<std::pair<double,std::string> > fitness;

  std::vector<std::map< std::pair<double,std::vector<int> >,double> > SV;

  std::pair<double,std::vector<int> >  FindBestChromosome();

  HelixPso(RNAParameters* p,SearchParameters* s,int clusters);
  static std::vector<std::vector<int> > FillGenepool(RNAParameters p,int genepool_size);

  static int  RandInt(int max);

  static double  RandDouble();



 void MemorizeBestSolution();
  void Elitism();

static std::pair<int,int> CorrectlyPredictedBpCount(std::string structure);

static  std::pair<int,int> CentroidMatchBpCount(std::string structure);

 bool HaveEnoughSolutions();

 void AddChromosome(std::vector<int> permutation);
 void AddSolution();
void AddAcceptedSolution();

// static std::vector<std::pair<double,std::vector<int> > > GetChromosomes(int population,std::string sequence,std::vector<std::vector<std::pair<int,int> > > stemlist,const std::vector<std::vector<int> >& genepool);

 void GetChromosomes();

  static std::vector<std::pair<int,int> > ChromosomeToNode(const std::vector<int> &chromosome,const std::vector<std::vector<std::pair<int,int> > >& stemlist);

  static std::vector<int> GetRandomPermutation(int n);



 void GetInitialPopulation();//const std::vector<std::vector<int> >& genepool);

  void SelectEliteSolution();
  void StoreBestSolution();

  void InitializeControlVariables();  

  void InitializeSV();


 void UpdateSV();

 void UpdatePbest();

 void UpdateGbest();

 void UpdateClbest();

 void CycleXover(std::vector<int>& p1 ,std::vector<int> p2);


static void CreateStemList(RNAParameters p);

 void Mutate(std::vector<int>& off);

  //void SetStemList( std::vector<std::vector<std::pair<int,int> > > stemlist);


//static   std::string PrintStemList();

  std::string PrintReferencePoints(std::map< std::pair<double,std::vector<int> >,double> m);



  // std::pair<double,std::string>  Evaluate(std::vector<int> chromosome); 


  // double Evaluate(std::vector<int> chromosome);
  std::pair<double,std::string>  Evaluate(std::vector<std::pair<int,int> > node);
  std::pair<double,std::string>  Evaluate(std::vector<int> chromosome);

 void DoNonGreedyIteration();

 // void DoGreedyIteration();

  void DoIteration();
  bool MoveTowards(std::vector<int>& src,std::vector<int> tgt,std::vector<bool>& changed);


  std::vector<int>  GetRandomReference(int i);


 double GetTotalProbability( std::map<std::pair<double,std::vector<int> >,double> m);



 //  std::string GetPopulationStats();

  // int FindBestFitness();

  //int FindWorstFitness();
  int FindBestFitnessIdx(const std::vector<std::pair<double,std::vector<int> > >& chromosomes);

  int FindWorstFitnessIdx(std::vector<std::pair<double,std::vector<int> > > chromosomes);


  bool HasBetterFitness(double f1,double f2);


  // std::string PrintChromosome(int i);

  static std::string PrintPermutation(std::vector<int> p);


  void EvaluateChromosomes();


  std::vector<std::pair<int,int> > ChromosomeToNode(int i);

  static void InitializeTranspositionCounters();

  static void InitializeAcceptedSolutionCounter();

  static void PrepareSVStatistics(); 

  void DoSVStatistics(); 

  static std::string PrintStemlist();


  //  void SendGBest(int dest);
  //void ReceiveGBest(int src);
  int GetChromosomeSize();

   void SetStartAndStopIdx();

 void LocalUpdateGbest();

 bool LocalUpdateClbest(int idx);

  std::string I(); 
   /* 
 void MasterUpdateClBest();
  void BroadcastGbest();
  void ReceiveBroadCastGbest();



  void LocalUpdateGbest();
  void BcastUpdateGbest();

  bool LocalUpdateClbest(int idx);
  void BcastUpdateClbest(int idx,bool clbestChanged);


  void  TimeBarrierStop();
  void  TimeBarrierStart();

  void  TimeBarrierStop2();
  void  TimeBarrierStop3();
  void  TimeBarrierStop4();

  void Allreduce(locstruct & in,locstruct & out,const MPI::Op&);
  //  void Allreduce2(locstruct & in,locstruct & out,const MPI::Op&);

  void Bcast(int data[],int count,int src);
  //void Bcast2(int data[],int count,int src);
  */
};

#endif
